#ifndef DISPLAYLFRCONFIG_H
#define DISPLAYLFRCONFIG_H

#include <QWidget>
#include <QGridLayout>
#include <QLabel>
#include <QGroupBox>
#include <QVBoxLayout>
#include <QTime>
#include <QDate>
#include <QPushButton>
#include <QDir>

class DisplayLFRConfig : public QWidget
{
    Q_OBJECT
public:
    explicit DisplayLFRConfig(QWidget *parent = 0);
    QLabel label_v[5];
    QLabel label_e1[5];
    QLabel label_e2[5];
    QLabel label_f[4];
    QLabel label_d[5];
    QLabel label_s[5];

    QString defaultConfig;
    QString defaultStorageDirectory;

    QGroupBox *groupbox_displayLFRConfig;
    QGridLayout *layout_mainLayout;
    QVBoxLayout *layout_widgetLayout;

    void initDisplay();
    void setLabelFrames();
    void processCommonParameters( unsigned char sy_lfr_common_parameters );
    void updateDisplay(bool BW, bool SP0, bool SP1, bool R0, bool R1 , bool R2);
    void updateD( bool BW );
    void updateS( bool SP0, bool P1 );
    void updateF0( bool R0 );
    void updateF1( bool R1 );
    void updateF2( bool R2 );
    void updateF3( );

signals:

public slots:
    void setDefaultStorageDirectory(QString nameOfTheDirectory);

};

#endif // DISPLAYLFRCONFIG_H
