#ifndef LFRXMLHANDLER_H
#define LFRXMLHANDLER_H

#include <QObject>
#include <QXmlDefaultHandler>
#include "tmpackettoread.h"

class LFRXmlHandler : public QObject, public  QXmlDefaultHandler
{
    Q_OBJECT

public:
    explicit LFRXmlHandler(QObject *parent = 0);

    bool startDocument();
    bool startElement(const QString &, const QString &, const QString &qName,
                       const QXmlAttributes &);
    bool endElement(const QString &, const QString &, const QString & qName);

    bool fatalError(const QXmlParseException &exception);

    QStringList& names();
    QList<int>& indentations();

    void packetStoreHasChanged(QList<TMPacketToRead*> *ccsdsPacketStore);

private:
    QList<TMPacketToRead*> *ccsdsPacketStore;

    int indentationLevel;
    QStringList elementName;
    QList<int> elementIndentation;

signals:
    void displayMessage(QString);

};

#endif // LFRXMLHANDLER_H
