#include "spectra.h"

spectra::spectra(QWidget *parent, unsigned int nbSpectrum2DPlot, unsigned int keySize, unsigned int valueSize, double scaleFactor ) :
    QWidget(parent)
{
    layout_overallLayout = new QVBoxLayout(this);

    mainTabWidget = new QTabWidget( );

    this->nbSpectrum2DPlot = nbSpectrum2DPlot;

    spectrum = (Spectrum2DPlot**) malloc( nbSpectrum2DPlot * sizeof( Spectrum2DPlot* ) );

    for(unsigned int i = 0; i< nbSpectrum2DPlot; i++)
    {
        spectrum[i] = new Spectrum2DPlot( 0, keySize, valueSize, scaleFactor );
    }

    for(unsigned int i = 0; i< nbSpectrum2DPlot; i++)
    {
        mainTabWidget->addTab( spectrum[i], QString::number(i) );
    }

    layout_overallLayout->addWidget( mainTabWidget );

    this->setLayout( layout_overallLayout );
}

spectra::~spectra()
{
    for(unsigned int i = 0; i<nbSpectrum2DPlot; i++)
    {
        delete( spectrum[i] );
    }
    free( spectrum );
}

void spectra::updateScaleFactor(double scaleFactor)
{
    for(unsigned int i = 0; i<nbSpectrum2DPlot; i++)
    {
        spectrum[i]->updateScaleFactor( scaleFactor );
    }
}

void spectra::updateColorScaleMax(double newValue)
{
    for(unsigned int i = 0; i<nbSpectrum2DPlot; i++)
    {
        spectrum[i]->updateSpinBoxMaxDataColorScale( newValue );
    }
}

void spectra::updateColorScaleMin(double newValue)
{
    for(unsigned int i = 0; i<nbSpectrum2DPlot; i++)
    {
        spectrum[i]->updateSpinBoxMinDataColorScale( newValue );
    }
}

void spectra::setTabTitle(unsigned char tab, QString title)
{
    mainTabWidget->setTabText( tab, title );
}
