#include "wfpacket.h"

WFPacket::WFPacket(QObject *parent, unsigned int nbData) :
    QObject(parent)
{
    this->nbSamples = nbData;
    coarseTime = 0x00;
    fineTime = 0x00;
    //
    wf_v  = (short*) malloc( sizeof(short) * nbData );
    wf_e1 = (short*) malloc( sizeof(short) * nbData );
    wf_e2 = (short*) malloc( sizeof(short) * nbData );
    wf_b1 = (short*) malloc( sizeof(short) * nbData );
    wf_b2 = (short*) malloc( sizeof(short) * nbData );
    wf_b3 = (short*) malloc( sizeof(short) * nbData );
}

WFPacket::~WFPacket()
{
    free(wf_v);
    free(wf_e1);
    free(wf_e2);
    free(wf_b1);
    free(wf_b2);
    free(wf_b3);
}

void WFPacket::resetWaveforms()
{
    unsigned int k;

    for (k=0; k<this->nbSamples; k++)
    {
        this->wf_v[k] = 0;
        this->wf_e1[k] = 0;
        this->wf_e2[k] = 0;
        this->wf_b1[k] = 0;
        this->wf_b2[k] = 0;
        this->wf_b3[k] = 0;
    }
}
